angular.module('easyscott.ltc', [])
    .controller('LtcController', [ '$scope', 'WebsocketService', 'DeviceModel', 'ChannelModel', 'LtcService', function($scope, WebsocketService, DeviceModel, ChannelModel, LtcService) {
        var AudioContext = window.AudioContext || window.webkitAudioContext;
        $scope.audioCtx = new AudioContext({ latencyHint: 'interactive', sampleRate: 48000 });
        $scope.ctxLatency = (($scope.audioCtx.baseLatency || 0.005) + ($scope.audioCtx.outputLatency || 0.005)) * 1000;
        $scope.playDelay = 500 - $scope.ctxLatency;
        console.log($scope.playDelay);

        $scope.play = function() {
            var tcMillis = $scope.currentTcMillis() + 500 + (1000/$scope.tc.iFps);
            var streamer = new LtcService.LtcStreamer(tcMillis, $scope.tc.iFps, 48000);
            var delayNode = $scope.audioCtx.createDelay($scope.playDelay / 1000.0);
            delayNode.delayTime.value = $scope.playDelay / 1000.0;

            var source = $scope.audioCtx.createBufferSource();
            source.buffer = $scope.audioCtx.createBuffer(1, 1920, 48000);
            source.loop = true;

            var processor = $scope.audioCtx.createScriptProcessor(2048, 1, 1);
            processor.onaudioprocess = function(e) {
                streamer.fill(e.outputBuffer.getChannelData(0));
            };

            source.connect(processor);
            // processor.connect($scope.audioCtx.destination);
            processor.connect(delayNode);
            delayNode.connect($scope.audioCtx.destination);
            source.start();
        };

    }]);
