angular.module('easyscott.radar', [])
  .controller('RadarController', [ '$scope', 'WebsocketService', 'DeviceModel', 'ChannelModel', 'CjamSettingsService', function($scope, WebsocketService, DeviceModel, ChannelModel, CjamSettingsService) {

    // For easy layer-breaking access from the template
    $scope.cjam = CjamSettingsService;

    $scope.devices = DeviceModel.devices;

    $scope.status = {
      channel: {},
      cjamRunning: false,
      timecodeSet: false
    };

    $scope.editables = {
      channels: false
    };

    $scope.updateChannel = function() {
      CjamSettingsService.setChannel($scope.status.channel.value);
      $scope.editables.channel = false;
    };

    $scope.removeDevice = function(deviceId) {
      WebsocketService.sendMessage({
        request: 'DEVICE_COMMAND',
        id: deviceId,
        command: 'DELETE'
      });
    };

    $scope.updateDevice = function(device) {
      var message = {
        request: 'RENAME_DEVICE',
        id: device.id,
        name: device.name
      };

      WebsocketService.sendMessage(message);
    };

    CjamSettingsService.updateCjamStatus($scope.status);

    DeviceModel.addEventListener('change', function(type) {
      $scope.devices = DeviceModel.devices;
      CjamSettingsService.updateCjamStatus($scope.status);
      $scope.$apply();
    });

  }]);
