angular.module('easyscott.script', [])
    .controller('ScriptController', [ '$scope', 'WebsocketService', 'DeviceModel', 'ChannelModel', function($scope, WebsocketService, DeviceModel, ChannelModel) {
      $scope.busy = true;
      $scope.exists = false;
      $scope.uploadRunning = false;
      $scope.uploadPercent = 0;

      $scope.peekFile = function() {
        $scope.busy = true;
        $.ajax({
          type: "HEAD",
          url: "/script",
        }).success(function() {
          $scope.busy = false;
          $scope.exists = true;
          $scope.$apply();
        }).error(function() {
          $scope.busy = false;
          $scope.exists = false;
          $scope.$apply();
        })
      };

      $scope.upload = function(ev) {
        ev.preventDefault();
        $scope.clearAlerts();

        if (!$scope.file) {
          // $scope.addAlert('danger', 'Please select a file to upload');
          return;
        }

        if (!$scope.file.name.match(/\.pdf$/)) {
          // $scope.addAlert('danger', 'Format not supported, please select a .pdf file.');
          return;
        }

        $scope.uploadRunning = true;
        var data = new FormData();
        data.append("file", $scope.file);

        $.ajax({
          url: '/script',
          type: 'POST',
          data: data,
          cache: false,
          processData: false,
          contentType: false,
          xhr: function() {
            var xhr = new window.XMLHttpRequest();
            xhr.upload.addEventListener('progress', $scope.updateProgress, false);
            return xhr;
          },
          success: function(data) {
            $scope.uploadRunning = false;
            $scope.peekFile();
          },
          error: function(xhr) {
            $scope.uploadRunning = false;
            $scope.clearAlerts();
            $scope.addAlert('danger', 'An error occured while uploading the file: ' + xhr.responseText);
          }
        });
      };

      $scope.updateProgress = function(event) {
        if (event.lengthComputable) {
          $scope.uploadPercent = parseInt(event.loaded / event.total * 100);
          $scope.$apply();
        }
      };

      $scope.deleteScript = function() {
        $scope.clearAlerts();

        $.ajax({
          type: "DELETE",
          url: "/script"
        }).success(function () {
          $scope.peekFile();
        }).error(function() {
          $scope.addAlert('danger', 'Delete failed');
          $scope.peekFile();
          $scope.$apply();
        })
      };

      $scope.peekFile();

      $scope.$on('$viewContentLoaded', function() {
        document.getElementById("script-upload").addEventListener('change', function (ev) {
          $scope.upload(ev);
          $scope.$apply();
        });
      });
    }]);
