angular.module('easyscott.filters', [])
    .filter('connectionStateToPanelClass', function () {
      return function (input) {
        if (input) {
          return 'panel-success';
        } else {
          return 'panel-default';
        }
      };
    })
    .filter('deviceStateToPanelClass', function () {
      return function (input) {
        var connected = input.connected;
        var internalState = input.state;

        if (connected) {
          switch (internalState) {
            case 'WARNING':
              return 'panel-warning2';
            case 'ERROR':
              return 'panel-danger';
          }
          return 'panel-success';
        } else {
          return 'panel-default';
        }
      };
    })
    .filter('deviceTypeToLabel', function () {
      return function (input) {
        if (input === 'alexa') {
          return 'Alexa';
        } else if (input === 'arricap2') {
          return 'ARRI CAP';
        } else if (input === 'red') {
          return 'RED';
        } else if (input === 'acn') {
          return 'ACN';
        } else if (input === 'websocket') {
          return 'Browser';
        } else if (input === 'socketapi') {
          return 'iPad';
        } else if (input === 'cube') {
          return 'Cube';
        } else if (input === 'vitec') {
          return 'Vitec';
        } else if (input === 'clink') {
          return 'Sound Recorder';
        } else if (input === 'zeiss') {
          return 'Lens';
        }
        return 'n/a';
      };
    })
    .filter('deviceTypeToIconClass', function () {
      return function (input) {
        switch (input) {
            // cameras
          case 'acn':
          case 'alexa':
          case 'arricap2':
          case 'lanc':
          case 'red':
          case 'zeiss':
            return 'fa fa-video-camera';

            // sound devices
          case 'clink':
            return 'fa fa-microphone';

            // recorders
          case 'cube':
          case 'vitec':
            return 'glyphicon glyphicon-record';

            // tablet clients
          case 'socketapi':
            return 'fa fa-tablet';

            // web clients
          case 'websocket':
            return 'glyphicon glyphicon-cloud';

          default:
            return 'n/a';
        }
      };
    })
    .filter('channelTypeToLabel', function () {
      return function (input) {
        if (input === 'acn') {
          return 'ACN';
        } else if (input === 'socketapi') {
          return 'Transfer API';
        } else if (input === 'websocket') {
          return 'Websocket';
        } else if (input === 'alexa') {
          return 'Alexa';
        } else if (input === 'arricap2') {
          return 'ARRI CAP';
        } else if (input === 'red') {
          return 'RED';
        } else if (input === 'cube') {
          return 'Cube';
        } else if (input === 'vitec') {
          return 'Vitec';
        } else if (input === 'clink') {
          return 'Sound Recorder';
        } else if (input === 'zeiss') {
          return 'Zeiss';
        }
        return 'n/a';
      };
    })
    .filter('channelTypeToConnectionType', function () {
      return function (input) {
        switch (input) {
            // ACN
          case 'acn':
            return 'ACN';

            // WiFi
          case 'socketapi':
            return 'WiFi';

            // Websocket
          case 'websocket':
            return 'Websocket';

            // Ethernet
          case 'alexa':
          case 'arricap2':
          case 'cube':
          case 'vitec':
            return 'Ethernet';

            // Serial
          case 'red':
          case 'clink':
          case 'zeiss':
            return 'Serial';

            // LANC
          case 'lanc':
            return 'LANC';

          default:
            return 'n/a';
        }
      };
    })
    .filter('connectionTypeIconClass', function () {
      return function (input) {
        if (input === 'WiFi') {
          return 'fa fa-wifi';
        } else if (input === 'Ethernet') {
          return 'fa fa-tty';
        } else if (input === 'Serial') {
          return 'fa fa-plug';
        } else if (input === 'LANC') {
          return 'fa fa-tty';
        }
        return 'fa fa-times';
      };
    })
    .filter('energyLevelToLabel', function () {
      return function (input) {
        if (input === 'LEVEL_0') {
          return '0 %';
        } else if (input === 'LEVEL_10') {
          return '10 %';
        } else if (input === 'LEVEL_20') {
          return '20 %';
        } else if (input === 'LEVEL_30') {
          return '30 %';
        } else if (input === 'LEVEL_40') {
          return '40 %';
        } else if (input === 'LEVEL_50') {
          return '50 %';
        } else if (input === 'LEVEL_60') {
          return '60 %';
        } else if (input === 'LEVEL_70') {
          return '70 %';
        } else if (input === 'LEVEL_80') {
          return '80 %';
        } else if (input === 'LEVEL_90') {
          return '90 %';
        } else if (input === 'LEVEL_100') {
          return '100 %';
        } else if (input === 'EXTERNALPOWER') {
          return 'Ext. Power';
        }
        return 'n/a';
      };
    })
    .filter('lockitTypeToImagePath', function () {
      return function (input) {
        if (input === 'ACN_TL') {
          return 'images/tinylockit.png';
        } else if (input === 'ACL204') {
          return 'images/lockit.png';
        } else if (input === 'ACN_SLATE') {
          return 'images/slate.png';
        } else if (input === 'ACN_ML') {
          return 'images/masterlockit.png';
        } else if (input === 'ACN_USB') {
          return 'images/USBStick.png';
        } else if (input === 'ACN_TLM') {
          return 'images/lockit.png';
        } else if (input === 'ACN_NL') {
          return 'images/nanolockit.png';
        } else if (input === 'ACN_NLM') {
          return 'images/lockit.png';
        } else if (input === 'ACN_CL') {
          return 'images/CL_Front.png';
        }
        return 'images/lockit.png';
      };
    })
    .filter('lockitTypeToLabel', function () {
      return function (input) {
        if (input === 'ACN_TL') {
          return 'TinyLockit';
        } else if (input === 'ACL204') {
          return 'Lockit ACL204';
        } else if (input === 'ACN_SLATE') {
          return 'LockitSlate';
        } else if (input === 'ACN_ML') {
          return 'MasterLockit';
        } else if (input === 'ACN_USB') {
          return 'ACN-USB-Stick';
        } else if (input === 'ACN_TLM') {
          return 'TLM';
        } else if (input === 'ACN_NL') {
          return 'NanoLockit';
        } else if (input === 'ACN_NLM') {
          return 'NLM';
        } else if (input === 'ACN_CL') {
          return 'Lockit';
        }
        return 'n/a';
      };
    })
    .filter('lockitBatteryTypeToLabel', function () {
      return function (input) {
        if (input === 'LITHIUM') {
          return 'Lithium';
        } else if (input === 'ALKALINE') {
          return 'Alkaline';
        } else if (input === 'NIMH') {
          return 'NiMH';
        } else if (input === 'LIION') {
          return 'LiIon';
        }
        return '';
      };
    })
    .filter('extractFramerateName', function () {
      return function (device) {
        if (!device || !device.properties) {
          return 'n/a';
        }
        if (device.properties.projectFramerate) {
          return extractProjectFramerateName(device.properties.projectFramerate);
        } else {
          return extractFramerateName(device.properties.lockitFramerate);
        }
      }
    })
    .filter('lockitFramerateToLabel', function () {
      return function (input) {
        return extractFramerateName(input);
      };
    })
    .filter('formatTimecodeObject', function () {
      return function (input) {
        var hours = Math.floor(input.seconds / 3600);
        var minutes = Math.floor((input.seconds % 3600) / 60);
        var seconds = input.seconds % 60;
        var frames = input.frames;

        var result = '';

        if (hours < 10) {
          result += '0';
        }
        result += hours + ':';

        if (minutes < 10) {
          result += '0';
        }
        result += minutes + ':';

        if (seconds < 10) {
          result += '0';
        }
        result += seconds + ':';

        if (frames < 10) {
          result += '0';
        }
        result += frames;

        return result;
      };
    })
    .filter('formatTimecodeObject2', function () {
      return function (input) {
        var hours = input.hours;
        var minutes = input.minutes;
        var seconds = input.seconds;
        var frames = input.frames;

        var result = '';

        if (hours < 10) {
          result += '0';
        }
        result += hours + ':';

        if (minutes < 10) {
          result += '0';
        }
        result += minutes + ':';

        if (seconds < 10) {
          result += '0';
        }
        result += seconds + ':';

        if (frames < 10) {
          result += '0';
        }
        result += frames;

        return result;
      };
    })
    .filter('formatSeconds', function () {
      return function (input) {
        var hours = Math.floor(input / 3600);
        var minutes = Math.floor((input % 3600) / 60);
        var seconds = input % 60;

        var result = '';

        if (hours < 10) {
          result += '0';
        }
        result += hours + ':';

        if (minutes < 10) {
          result += '0';
        }
        result += minutes + ':';

        if (seconds < 10) {
          result += '0';
        }
        result += seconds;

        return result;
      };
    })
    .filter('formatSecondsToMinutes', function () {
      return function (input) {
        var minutes = Math.floor(input / 60);
        var seconds = input % 60;

        var result = '';
        if (minutes < 10) {
          result += '0';
        }
        result += minutes + ':';

        if (seconds < 10) {
          result += '0';
        }
        result += seconds;

        return result;
      };
    })
    .filter('padTimeComponent', function () {
      return function (input) {
        return (input < 10 ? "0" : "") + input
      }
    })
    .filter('toActiveClass', function () {
      return function (input) {
        return input ? "active" : "";
      }
    })
    .filter('smallDebianRevision', function () {
      return function (input) {
        if (input.indexOf('~') > 0) {
          return input.substr(0, input.indexOf('~')) + '<small>' + input.substr(input.indexOf('~')) + '</small>';
        }
        return input;
      };
    })
    .filter('userConfigurableChannels', function () {
      return function (input) {
        return _.filter(input, function (channel) {
          return channel.type === 'alexa' || channel.type === 'clink' || channel.type === 'red' || channel.type === 'arricap2';
        })
      }
    })
    .filter('trimColons', function () {
      return function (input) {
        return input.replace(/:/g, "");
      }
    })
    .filter('localDateTime', function () {
      return function(input) {
        if (input) {
          var date = new Date(parseInt(input, 10));
          return date.toLocaleDateString() + " " + date.toLocaleTimeString();
        } else {
          return "-";
        }
      };
    })
    .filter('wifiMode', function () {
      return function(input) {
          if (input === 'client') {
            return 'Client';
          } else {
            return 'Host';
          }
      };
    })
    .filter('orderByProjectDayAndTimecode', function () {
      return function (input, reverse) {
        var compareTimecodes = function (a, b) {
          if (a != null && b != null) {
            if (a.tcStartSeconds < b.tcStartSeconds) {
              return -1;
            } else if (a.tcStartSeconds > b.tcStartSeconds) {
              return 1;
            } else {
              if (a.tcStartFrames < b.tcStartFrames) {
                return -1;
              } else if (a.tcStartFrames < b.tcStartFrames) {
                return 1;
              }
            }
          }
          return 0;
        };
        var compareProjectDaysAndTimecode = function (a, b) {
          if (a.projectDay == null && b.projectDay == null) {
            return compareTimecodes(a, b);
          } else if (a.projectDay == null && b.projectDay != null) {
            return -1;
          } else if (a.projectDay != null && b.projectDay == null) {
            return 1;
          }

          var projectDayA = a.projectDay;
          var projectDayB = b.projectDay;

          if (projectDayA.number < projectDayB.number) {
            return -1;
          } else if (projectDayA.number > projectDayB.number) {
            return 1;
          }

          var additionalA = jQuery.trim(projectDayA.number);
          var additionalB = jQuery.trim(projectDayB.number);

          if (additionalA < additionalB) {
            return -1;
          } else if (additionalA > additionalB) {
            return 1;
          }

          return compareTimecodes(a, b);
        };

        var sortedArray = input.slice(0);
        sortedArray.sort(compareProjectDaysAndTimecode);

        if (reverse) {
          sortedArray.reverse();
        }

        return sortedArray;
      }
    });

function extractFramerateName(input) {
  if (input === 'FPS_23F' || parseInt(input) === 0) {
    return '23 FPS';
  } else if (input === 'FPS_24F' || parseInt(input) === 1) {
    return '24 FPS';
  } else if (input === 'FPS_25F' || parseInt(input) === 2) {
    return '25 FPS';
  } else if (input === 'FPS_29F' || parseInt(input) === 3) {
    return '29 FPS';
  } else if (input === 'FPS_30F' || parseInt(input) === 4) {
    return '30 FPS';
  } else if (input === 'FPS_29DF' || parseInt(input) === 5) {
    return '29 Drop';
  } else if (input === 'FPS_30DF' || parseInt(input) === 6) {
    return '30 Drop';
  }
  return 'n/a';
}

function extractProjectFramerateName(input) {
  var projectFramerateOptions = [
    { value: 'FPS_23_98', text: '23.976 FPS' },
    { value: 'FPS_24', text: '24 FPS' },
    { value: 'FPS_25', text: '25 FPS' },
    { value: 'FPS_29_97', text: '29.97 FPS' },
    { value: 'FPS_29_97_DROP', text: '29.97 Drop' },
    { value: 'FPS_30', text: '30 FPS' },
    { value: 'FPS_30_DROP', text: '30 Drop' },
    { value: 'FPS_47_95', text: '47.952 FPS' },
    { value: 'FPS_48', text: '48 FPS' },
    { value: 'FPS_50', text: '50 FPS'},
    { value: 'FPS_59_94', text: '59.94 FPS' },
    { value: 'FPS_59_94_DROP', text: '59.94 Drop' },
    { value: 'FPS_60', text: '60 FPS' },
    { value: 'FPS_60_DROP', text: '60 Drop' }
  ];

  return _.chain(projectFramerateOptions)
      .filter(function(o) { return o.value === input })
      .map(function(o) { return o.text })
      .first()
      .value() || 'n/a';
}

