var DeviceModel = EventDispatcher.extend({
  started: false,
  devices: [],
  service: null,

  start: function() {
    if(!this.started) {
      this.service.addEventListener('message', jQuery.proxy(function(type, message) {
        if(message.request == "DEVICE_STATE") {
          this.updateOrInsert(message);
        }
      }, this));

      this.started = true;
    }
  },
  updateOrInsert: function(newDevice) {
    var newDevices = _.filter(this.devices, function(d) {
      return d.id != newDevice.id;
    });

    if(newDevice.removed == false) {
      newDevices.push(newDevice);
    }

    this.devices = newDevices;
    this.dispatchEvent('change');
  },
  getMasterclockDevice: function() {
    var masterClockDevices = _.filter(this.devices, function(d) {
      if(d.deviceTypes.indexOf('TIMECODE_GENERATOR') != -1) {
        return d.deviceTypeProperties.TIMECODE_GENERATOR.masterClock == "true";
      }
      return false;
    });
    
    return _.first(masterClockDevices);
  },
  getCLinkDevice: function() {
    return _.find(this.devices, function(d) {
      return d.type == "clink" && d.connected && !d.parentDeviceId;
    });
  }
});

(function () {
  var DeviceModelProvider = Class.extend({
    instance: new DeviceModel(),
    $get:['WebsocketService', function(websocketService) {
      this.instance.service = websocketService;
      return this.instance;
    }]
  })
  angular.module('easyscott.DeviceModel',['easyscott.WebsocketService']).provider('DeviceModel',DeviceModelProvider);
}());
