var SlateModel = EventDispatcher.extend({
  started: false,
  upcomingSlateInfo: [],
  service: null,

  start: function() {
    if(!this.started) {
      this.service.addEventListener('message', jQuery.proxy(function(type, message) {
        if(message.request == "SLATEINFO") {
          this.upcomingSlateInfo = message.slateInfo;
          this.dispatchEvent('change');
        }
      }, this));
      
      this.service.sendMessage({
        request: 'REQUEST_SLATEINFO',
      });

      this.started = true;
    }
  },
});

(function () {
  var SlateModelProvider = Class.extend({
    instance: new SlateModel(),
    $get:['WebsocketService', function(websocketService) {
      this.instance.service = websocketService;
      return this.instance;
    }]
  })
  angular.module('easyscott.SlateModel', ['easyscott.WebsocketService']).provider('SlateModel', SlateModelProvider);
}());
