var ClipMetadataTableCreator = function() {};

ClipMetadataTableCreator.prototype.createTable = function(clip, callback) {
  var self = this;

  $.ajax('/clips/', {
    type: 'GET',
    data: {
      clipIds: clip.id,
      format: 'csv'
    }
  }).success(function(csv) {
    self.createTableWithCsv(csv, callback);
  });
};

ClipMetadataTableCreator.prototype.createTableWithCsv = function(csv, callback) {
  var lines = Papa.parse(csv).data
  var table =  $("<table>")
      .addClass('table')
      .addClass('table-bordered')
      .addClass('table-striped');

  if (lines.count < 2) {
    callback(table);
    return;
  }

  var columns = lines[0]
  var values = lines[1]

  if (columns.length != values.length) {
    callack(table);
    return;
  }

  for (var i = 0; i < columns.length; i++) {
    var column = columns[i];
    var value = values[i];

    if (value !== '') {
      var row = $('<tr>');
      row.append($('<td>').text(column));

      if (value === 'false') {
        row.append($('<td>').append($('<i>').addClass('glyphicon glyphicon-remove')));
      } else if (value === 'true') {
        row.append($('<td>').append($('<i>').addClass('glyphicon glyphicon-ok')));
      } else {
        row.append($('<td>').text(value));
      }

      table.append(row);
    }
  }

  callback(table);
};

(function () {
  var ClipMetadataTableCreatorProvider = Class.extend({
    instance: new ClipMetadataTableCreator(),
    $get: [function() {
      return this.instance;
    }]
  });
  angular.module('easyscott.ClipMetadataTableCreator',[]).provider('ClipMetadataTableCreator', ClipMetadataTableCreatorProvider);
}());
