var ReportService = function() {};

ReportService.prototype.requestReport = function(reportType, reportData, callback) {
    $.ajax("/report/" + reportType, {
        type: "POST",
        contentType: "application/json; charset=UTF-8",
        processData: false,
        data: JSON.stringify(reportData),
        success: function(data) {
            callback(null, data);
        },
        error: function(xhr, status, error) {
            callback(error);
        }
    });
};

ReportService.prototype.downloadReport = function(fileName, downloadFileName) {
    var url = "/report/" + fileName;
    if (downloadFileName) {
        url += "?filename=" + encodeURI(downloadFileName);
    }
    window.location = url;
};

(function () {
    var ReportServiceProvider = Class.extend({
        instance: new ReportService(),
        $get: [function() {
            return this.instance;
        }]
    });
    angular.module('easyscott.ReportService',[]).provider('ReportService', ReportServiceProvider);
}());
