var errorStack = [];

function reboot() {
  if (confirm('The connection to the camera will drop for approximately 5 minutes on reboot!')) {
    window.location.href = "/reboot.php";
  }
}

function shutdown() {
  if (confirm('Do you really what to shutdown?')) {
    window.location.href = "/shutdown.php";
  }
}

function checkReboot() {
  $.ajax('/reboot_status.php',
         {
           success: function (data) {
             if ('0' === data) {
               window.location.href = "/";
             }
             else {
               window.setTimeout(checkReboot, 5000);
             }
           }
         });
}

function checkStatus(ip, element) {
  var content = element.innerHTML;

  element.innerHTML = 'check ...';
  $.ajax('ping.php?ip=' + ip,
         {
           success: function (data) {
             if ('1' === data) {
               alert('Device is ready');
             } else if ('0' === data) {
               alert('Could not find device.');
             } else {
               alert('This device does not support this action.');
             }
             element.innerHTML = 'test';
           },
           error: function (data) {
             alert('This device does not support this action.');
             element.innerHTML = 'test';
           }
         });
}

function performReboot() {
  $.ajax('/reboot_perform.php');
}

function performShutdown() {
  $.ajax('/shutdown_perform.php');
}

function updateStatus() {
  $.ajax('/load_status.php',
         {
           success: function (data) {
             $('#status').html(data);
             window.setTimeout(updateStatus, 1000);
           }
         });
}

function loadCamera(id) {
  $.ajax('/load_camera.php?id=' + id,
         {
           success: function (data) {
             $('#camera').html(data);
           }
         });
}

function loadWifi(mode) {
  $.ajax('/load_wifi.php?mode=' + mode,
         {
           success: function (data) {
             $('#wifi').html(data);
           }
         });
}

function loadCameraPattern(id, type) {
  $.ajax('/load_cameraPattern.php?id=' + id + '&type=' + type,
         {
           success: function (data) {
             $('#pattern').html(data);
           }
         });
}

function updateCamera(id, action) {
  $.ajax('/update_camera.php?id=' + id + '&action=' + action,
         {
           success: function (data) {
             $('#pattern').html(data);
           }
         });
}

function loadRecorder(id) {
  $.ajax('/load_recorder.php?id=' + id,
         {
           success: function (data) {
             $('#recorder').html(data);
           }
         });
}

function enableGeneratorMode() {
  $.ajax('/update_generatormode.php?state=1');
}

function disableGeneratorMode() {
  $.ajax('/update_generatormode.php?state=0');
}

function startCJam() {
  $.ajax('/startcjam.php');
}

function setTimecode() {
  $.ajax('/set_timecode.php', {
    method: 'POST',
    data: {
      hours: jQuery('#tcHours').val(),
      minutes: jQuery('#tcMinutes').val(),
      seconds: jQuery('#tcSeconds').val(),
      frames: jQuery('#tcFrames').val(),
    },
    success: function(data) {
      jQuery('#tcHours').val('');
      jQuery('#tcMinutes').val('');
      jQuery('#tcSeconds').val('');
      jQuery('#tcFrames').val('');
    }
  });
}
